import IJsonObject from "../../IJsonObject";
import IPrompt from "./IPrompt";
import IPromptValidator from "./IPromptValidator";
/**
 * @inheritdoc
 */
export default class PromptValidator<TEvent extends IJsonObject> implements IPromptValidator<TEvent> {
    /**
     * @inheritdoc
     */
    back(prompt: IPrompt<TEvent>): {
        readonly type: `invalidControl`;
    } | {
        readonly type: `success`;
        readonly event: TEvent;
    };
    /**
     * @inheritdoc
     */
    text(text: string, prompt: IPrompt<TEvent>): {
        readonly type: `invalidControl`;
    } | {
        readonly type: `tooShort`;
    } | {
        readonly type: `tooLong`;
    } | {
        readonly type: `success`;
        readonly event: TEvent;
    };
    /**
     * @inheritdoc
     */
    password(password: string, prompt: IPrompt<TEvent>): {
        readonly type: `invalidControl`;
    } | {
        readonly type: `tooShort`;
    } | {
        readonly type: `tooLong`;
    } | {
        readonly type: `success`;
        readonly event: TEvent;
    };
    /**
     * @inheritdoc
     */
    number(number: number, prompt: IPrompt<TEvent>): {
        readonly type: `invalidControl`;
    } | {
        readonly type: `lessThanMinimum`;
    } | {
        readonly type: `greaterThanMaximum`;
    } | {
        readonly type: `invalidStep`;
    } | {
        readonly type: `success`;
        readonly event: TEvent;
    };
    /**
     * @inheritdoc
     */
    multipleChoiceByLabel(label: string, prompt: IPrompt<TEvent>): {
        readonly type: `invalidControl`;
    } | {
        readonly type: `invalidLabel`;
    } | {
        readonly type: `success`;
        readonly event: TEvent;
    };
    /**
     * @inheritdoc
     */
    multipleChoiceByIndex(index: number, prompt: IPrompt<TEvent>): {
        readonly type: `invalidControl`;
    } | {
        readonly type: `indexOutOfRange`;
    } | {
        readonly type: `success`;
        readonly event: TEvent;
    };
}
